unit DssUnit;

interface

uses math,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TDssForm = class(TForm)
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Edit5: TEdit;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Edit6: TEdit;
    Edit7: TEdit;
    Edit8: TEdit;
    Edit9: TEdit;
    Label9: TLabel;
    Button1: TButton;
    Edit10: TEdit;
    Label10: TLabel;
    Label11: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  DssForm: TDssForm;

implementation

{$R *.DFM}
  type SImageConfig = record
     pDir : Pchar;
     pDrive : Pchar;
     pImageFile : Pchar;
     DataSource : integer;
     PromptForDisk : boolean;
     SubSample : integer;
     Ra : double;
     De : double;
     Width : double;
     Height : double;
     Sender : Thandle;
     pApplication :Pchar;
     pPrompt1 : Pchar;
     pPrompt2 : Pchar;
  end;
  type Plate_data = record
   nplate : integer;
   plate_name, gsc_plate_name : array[1..10]of Pchar;
   dist_from_edge, cd_number, is_uk_survey : array[1..10]of integer;
   year_imaged, exposure : array[1..10]of double;
  end;
  PImageConfig = ^SImageConfig;
  PPlate_data = ^Plate_data;

type TImageExtract=function( img : PImageConfig): Integer; Cdecl;
     TGetPlateList=function( img : PImageConfig; pl : PPlate_data): Integer; Cdecl;
     TImageExtractFromPlate=function( img : PImageConfig; ReqPlateName : Pchar): Integer; Cdecl;
var  ImageExtract: TImageExtract;
     GetPlateList: TGetPlateList;
     ImageExtractFromPlate: TImageExtractFromPlate;
     dsslib : integer;


procedure TDssForm.Button1Click(Sender: TObject);
var i : SImageConfig;
    rc : integer;
    dir,drv,ima : string;
begin
  edit10.text:='';
  dir:=trim(edit6.text);
  drv:=trim(edit7.text);
  ima:=trim(edit8.text);
  i.pDir:=Pchar(dir);
  i.pDrive:=Pchar(drv);
  i.pImageFile:=Pchar(ima);
  i.DataSource:=strtoint(edit9.text);
  i.PromptForDisk:=true;
  i.SubSample:=strtoint(edit5.text);
  i.Ra:=degtorad(strtofloat(edit1.text)*15);
  i.De:=degtorad(strtofloat(edit2.text));
  i.Width:=strtofloat(edit3.text);
  i.Height:=strtofloat(edit4.text);
  i.Sender:=DssForm.handle;
  i.pApplication:='Test DSS';
  i.pPrompt1:='Veuillez monter le CD RealSky n';
  i.pPrompt2:='dans le lecteur';
  rc:=ImageExtract(addr(i));
  edit10.text:=inttostr(rc);
end;

procedure TDssForm.FormShow(Sender: TObject);
begin
  dsslib := LoadLibrary('getdss.dll');
  if dsslib<>0 then begin
    ImageExtract:= TImageExtract(GetProcAddress(dsslib, 'ImageExtract'));
    GetPlateList:= TGetPlateList(GetProcAddress(dsslib, 'GetPlateList'));
    ImageExtractFromPlate:= TImageExtractFromPlate(GetProcAddress(dsslib, 'ImageExtractFromPlate'));
  end else begin
    showmessage('getdss.dll not found !');
    close;
  end;
end;

end.
